// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

package frc.robot.commands;

import java.util.List;

import edu.wpi.first.math.controller.HolonomicDriveController;
import edu.wpi.first.math.controller.PIDController;
import edu.wpi.first.math.controller.ProfiledPIDController;
import edu.wpi.first.math.geometry.Pose2d;
import edu.wpi.first.math.geometry.Translation2d;
import edu.wpi.first.math.kinematics.ChassisSpeeds;
import edu.wpi.first.math.kinematics.SwerveModuleState;
import edu.wpi.first.math.trajectory.Trajectory;
import edu.wpi.first.math.trajectory.TrajectoryConfig;
import edu.wpi.first.math.trajectory.TrajectoryGenerator;
import edu.wpi.first.wpilibj.Timer;
import edu.wpi.first.wpilibj.smartdashboard.SmartDashboard;
import edu.wpi.first.wpilibj2.command.Command;
import frc.robot.Constants;
import frc.robot.subsystems.Swerve;

/**
 * Drives the robot while following a trajectory generated by a list of points
 */
public class TrajectorySwerve extends Command {
    private final Swerve swerve;
    private final List<Pose2d> points;

    private final HolonomicDriveController controller;
    private final ProfiledPIDController thetaController;

    private final Trajectory trajectory;

    private double startTime;

    /** Creates a new TrajectorySwerve. */
    public TrajectorySwerve(Swerve swerve, List<Pose2d> points) {
        this.swerve = swerve;
        this.points = points;

        this.thetaController = new ProfiledPIDController(
                Constants.AutoConstants.DRIVE_THETA_P, 
                0, 
                0, 
                Constants.AutoConstants.DRIVE_THETA_CONSTRAINTS
        );
        
        this.thetaController.setTolerance(Math.toRadians(3));

        this.controller = new HolonomicDriveController(
            new PIDController(
                Constants.AutoConstants.DRIVE_X_P, 
                0, 
                0
            ), 
            new PIDController(
                Constants.AutoConstants.DRIVE_Y_P, 
                0, 
                0
            ), 
            thetaController
        );
        this.trajectory = TrajectoryGenerator.generateTrajectory(
            points,
            new TrajectoryConfig(
                Constants.AutoConstants.MAX_SPEED, 
                Constants.AutoConstants.MAX_ACCELERATION
            )
        );

        // Use addRequirements() here to declare subsystem dependencies.
        addRequirements(swerve);
    }

    // Called when the command is initially scheduled.
    @Override
    public void initialize() {
        startTime = Timer.getFPGATimestamp();
        SmartDashboard.putString("Final Trajectory Pose", points.get(points.size() - 1).toString());
    }

    // Called every time the scheduler runs while the command is scheduled.
    @Override
    public void execute() {
        ChassisSpeeds speeds = controller.calculate(
            swerve.getPose(), 
            trajectory.sample(Timer.getFPGATimestamp() - startTime), 
            points.get(points.size() - 1).getRotation()
        );
        SwerveModuleState[] states = Constants.Swerve.swerveKinematics.toSwerveModuleStates(speeds);
        for (SwerveModuleState state : states) {
            state.speedMetersPerSecond *= -1;
        }
        swerve.setModuleStates(states);
    }

    // Called once the command ends or is interrupted.
    @Override
    public void end(boolean interrupted) {
        // Stops driving
        swerve.drive(new Translation2d(), 0, true);
    }

    /**
     * Gets the time it will take to run the trajectory
     * @return Time in seconds
     */
    public double getTime() {
        return trajectory.getTotalTimeSeconds();
    }

    // Returns true when the command should end.
    @Override
    public boolean isFinished() {
        return Timer.getFPGATimestamp() - startTime > trajectory.getTotalTimeSeconds();
    }
}
